'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _jquery = require('jquery');

var _jquery2 = _interopRequireDefault(_jquery);

var _uiView = require('@gec/ui-view');

var _uiView2 = _interopRequireDefault(_uiView);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) {
    if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); }
    subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } });
    if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
}

var UIColFix = function(_UIView) {
    _inherits(UIColFix, _UIView);

    function UIColFix() {
        var options = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

        _classCallCheck(this, UIColFix);

        var _this = _possibleConstructorReturn(this, (UIColFix.__proto__ || Object.getPrototypeOf(UIColFix)).call(this, _jquery2.default.extend({
            className: 'ui-colfix'
        }, options)));

        var $element = _this.$el;

        var stickBottom = $element.data('stick') == "bottom",
            child = $element.data('child');
        var isIpad = /iPad/.test(navigator.userAgent); // hc :(
        var cfscroll = function cfscroll(e) {

            if (isIpad) {
                return;
            }

            if (e.data.$parent.height() - e.data.$element.height() < 50) {
                e.data.$element.css('top', '').removeClass('ui-colfixed').removeClass('ui-colabsoluted');
                return;
            }
            var hw = (0, _jquery2.default)('html').scrollTop() || (0, _jquery2.default)(window).scrollTop();
            if ($parent.outerHeight(true) < $element.outerHeight(true) || $element.data("con") && $element.outerHeight(true) + $element.outerHeight(true) / 2 > $parent.outerHeight(true)) {
                $element.removeClass('ui-colabsoluted ui-colfixed');
                return false;
            }
            e.data.itop = e.data.$i.offset().top;
            e.data.ptop = e.data.$parent.offset().top + e.data.$parent.outerHeight(true) - e.data.$element.outerHeight(true);
            var rest = stickBottom ? $element.outerHeight(true) - (0, _jquery2.default)(window).height() : 0;
            if (hw > e.data.itop + rest) {

                if (child) e.data.$element.css('width', $element.parent().outerWidth());
                if (hw < e.data.ptop + rest) {
                    e.data.$element.css('top', 0).addClass('ui-colfixed').removeClass('ui-colabsoluted').css('top', rest * -1);
                } else e.data.$element.css('top', e.data.ptop).addClass('ui-colabsoluted').removeClass('ui-colfixed');
            } else {
                e.data.$element.css({ 'top': '' }).removeClass('ui-colfixed').removeClass('ui-colabsoluted');
                if (child) e.data.$element.css({ 'width': 'inherit' });
            }

        };
        var itop, ptop, $parent;
        $element.before('<i/>');

        setTimeout(function() {
            $parent = (0, _jquery2.default)($element.data('fixto') || $element.parent());

            itop = $element.data('done', true).offset().top;
            ptop = $parent.offset().top + $parent.outerHeight(true) - $element.outerHeight(true);

            (0, _jquery2.default)(window).off('scroll.libui', cfscroll).on('scroll.libui touchmove', { $element: $element, $parent: $parent, $i: $element.prev() }, cfscroll);
            (0, _jquery2.default)(window).trigger('scroll.libui');

        }, 300);

        return _this;
    }

    return UIColFix;
}(_uiView2.default);

exports.default = UIColFix;


UIColFix.dataSetName = 'UIColFix';
_jquery2.default.fn.UIColFix = function() {
    return this.each(function() {
        var $el = (0, _jquery2.default)(this);
        var colfix = new UIColFix({
            el: $el
        }).saveDataset();
        $el.data("api", colfix);
    });
};